/*----------------------------------------------------------------
 *
 * print_sub.h
 *	  functions for pretty-printing query results
 *
 * Change Log
 * 2001.06.11: Add 'TableTag' struct.
 * 2001.06.11: Add header_tr,header_th,body_tag into PSprintOpt struct.
 * 2001.06.11: Add input_tag,input_size
 *
 *
 *
 *    This software is copyrighted by SAKAIDA Masaaki - Osaka,Japan.
 *    The author hereby grants permission  to  use,  copy,  modify,
 *    distribute,  and  license this software and its documentation
 *    for any purpose, provided that existing copyright notices are
 *    retained  in  all  copies  and  that  this notice is included
 *    verbatim in any distributions. No written agreement, license,
 *    or  royalty  fee  is required for any of the authorized uses.
 *    Modifications to this software may be  copyrighted  by  their
 *    author  and  need  not  follow  the licensing terms described
 *    here, provided that the new terms are  clearly  indicated  on
 *    the first page of each file where they apply.
 *    IN NO EVENT SHALL THE AUTHOR OR DISTRIBUTORS BE LIABLE TO ANY
 *    PARTY  FOR  DIRECT,   INDIRECT,   SPECIAL,   INCIDENTAL,   OR
 *    CONSEQUENTIAL   DAMAGES  ARISING  OUT  OF  THE  USE  OF  THIS
 *    SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN
 *    IF  THE  AUTHOR  HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH
 *    DAMAGE.
 *    THE  AUTHOR  AND  DISTRIBUTORS  SPECIFICALLY   DISCLAIM   ANY
 *    WARRANTIES,  INCLUDING,  BUT  NOT  LIMITED  TO,  THE  IMPLIED
 *    WARRANTIES  OF  MERCHANTABILITY,  FITNESS  FOR  A  PARTICULAR
 *    PURPOSE,  AND NON-INFRINGEMENT.  THIS SOFTWARE IS PROVIDED ON
 *    AN "AS IS" BASIS, AND THE AUTHOR  AND  DISTRIBUTORS  HAVE  NO
 *    OBLIGATION   TO   PROVIDE   MAINTENANCE,   SUPPORT,  UPDATES,
 *    ENHANCEMENTS, OR MODIFICATIONS.
 *-----------------------------------------------------------------
 */

#ifndef PRINT_SUB_HEADER
#define PRINT_SUB_HEADER

#ifndef bool
#define bool	char
#endif

/*-------------------------------------------------------------------
	The typedef of printing
-------------------------------------------------------------------*/
typedef struct _PSprintOpt
{
	bool            html3;		/* output html  tables          */
	bool            expanded;	/* set expand type              */

	char           *caption;	/* Table Title                  */
	bool            outerframe;	/* print table outer frame      */
	bool            header;		/* print output table headings  */
	bool            rowcount;	/* print output table row count */
	bool            align;		/* fill align the fields        */
	char           *nullstr;	/* NULL string                  */
	char           *zerostr;	/* ZERO string                  */
	char           *fieldSep;	/* field separator              */

	char           *table_tag;	/* HTML table tag    */
	char           *header_tr;	/* HTML header <TR> tag */
	char           *header_th;	/* HTML header <TH> tag */
	char           *body_tag;	/* HTML body <TD> tag */
	bool		input_tag;      /* HTML input tag flag(ON=1,OFF=0)*/
	char           *input_size;	/* HTML INPUT tag size */

	int             nFields;	/* number of Fields		 */
	int             nTups;		/* number of Tuples		 */
	char          **fieldName;	/* field name(null terminated)  */
	char          **fieldValue;	/* all field's value		 */
	short          *fieldMax;	/* field length                  */
	unsigned char  *fieldNotNum;	/* field is Number or not        */

}  PSprintOpt;


/*-------------------------------------------------------------------
 *	  Functions list
 *-----------------------------------------------------------------*/
extern void     PSprint(FILE * fout, PSprintOpt * Opt, int encoding);
extern int      alloc_printOpt(PSprintOpt * Opt, PGresult * res);
extern int      set_printOpt(PSprintOpt * Opt);
extern void     free_printOpt(PSprintOpt * Opt);



#endif
